From 460692de44296f32b9f4b5a2850e75ae47fa448d Mon Sep 17 00:00:00 2001
From: Zsolt Parragi <zsolt.parragi@percona.com>
Date: Tue, 17 Mar 2026 16:20:11 +0000
Subject: [PATCH 3/4] Add explicit padding to WAL record structs and annotate
 with PG_NO_PADDING

Annotate all struct types passed to XLogRegisterData() with PG_NO_PADDING
and add explicit padding fields where the compiler would insert implicit
padding.  This ensures no uninitialized bytes are written to WAL records.

For structs that previously used SizeOfXXXX macros (via offsetof + sizeof
of last field) to skip trailing padding, the macros are replaced with
sizeof() since the explicit padding makes the full struct safe to write.
This is a WAL format change: records now include the previously-skipped
trailing padding bytes, explicitly initialized to zero.

SizeOfXXXX macros for structs with FLEXIBLE_ARRAY_MEMBER are kept, as
they use offsetof() to compute the fixed portion size.
---
 src/backend/access/brin/brin.c                |  2 +-
 src/backend/access/brin/brin_pageops.c        |  6 +-
 src/backend/access/brin/brin_revmap.c         |  4 +-
 src/backend/access/gin/ginbtree.c             |  6 +-
 src/backend/access/gin/gindatapage.c          |  2 +-
 src/backend/access/gin/ginfast.c              |  9 +--
 src/backend/access/gin/ginutil.c              |  2 +-
 src/backend/access/gin/ginvacuum.c            |  2 +-
 src/backend/access/gist/gistxlog.c            | 10 +--
 src/backend/access/hash/hash.c                |  4 +-
 src/backend/access/hash/hashinsert.c          |  4 +-
 src/backend/access/hash/hashovfl.c            |  6 +-
 src/backend/access/hash/hashpage.c            |  8 +-
 src/backend/access/heap/heapam.c              | 32 ++++----
 src/backend/access/heap/heapam_xlog.c         |  6 +-
 src/backend/access/heap/pruneheap.c           | 10 +--
 src/backend/access/heap/rewriteheap.c         |  2 +-
 src/backend/access/nbtree/nbtdedup.c          |  2 +-
 src/backend/access/nbtree/nbtinsert.c         | 10 +--
 src/backend/access/nbtree/nbtpage.c           | 20 ++---
 src/backend/access/rmgrdesc/clogdesc.c        |  2 +-
 src/backend/access/rmgrdesc/xactdesc.c        |  4 +-
 src/backend/access/rmgrdesc/xlogdesc.c        |  6 +-
 src/backend/access/spgist/spgdoinsert.c       | 10 +--
 src/backend/access/spgist/spgvacuum.c         |  6 +-
 src/backend/access/spgist/spgxlog.c           | 14 ++--
 src/backend/access/transam/clog.c             |  4 +-
 src/backend/access/transam/commit_ts.c        |  2 +-
 src/backend/access/transam/multixact.c        |  8 +-
 src/backend/access/transam/xact.c             | 46 ++++++------
 src/backend/access/transam/xlog.c             | 25 ++++---
 src/backend/access/transam/xloginsert.c       |  5 +-
 src/backend/access/transam/xlogreader.c       |  3 +
 src/backend/access/transam/xlogrecovery.c     |  8 +-
 src/backend/catalog/storage.c                 |  4 +-
 src/backend/commands/dbcommands.c             | 10 +--
 src/backend/commands/sequence.c               | 12 +--
 src/backend/commands/tablecmds.c              |  2 +-
 src/backend/commands/tablespace.c             |  4 +-
 src/backend/postmaster/walsummarizer.c        |  6 +-
 src/backend/replication/logical/decode.c      |  2 +-
 src/backend/replication/logical/message.c     |  2 +-
 src/backend/replication/logical/origin.c      |  4 +-
 src/backend/storage/ipc/standby.c             | 14 ++--
 src/backend/utils/cache/inval.c               |  6 +-
 src/backend/utils/cache/relmapper.c           | 12 +--
 src/bin/pg_resetwal/pg_resetwal.c             |  1 +
 src/include/access/brin_xlog.h                | 30 ++++----
 src/include/access/clog.h                     |  2 +-
 src/include/access/commit_ts.h                |  6 +-
 src/include/access/ginblock.h                 |  6 +-
 src/include/access/ginxlog.h                  | 19 +++--
 src/include/access/gistxlog.h                 | 24 ++++--
 src/include/access/hash_xlog.h                | 56 +++++++-------
 src/include/access/heapam_xlog.h              | 75 ++++++++++++-------
 src/include/access/multixact.h                |  6 +-
 src/include/access/nbtxlog.h                  | 53 +++++++------
 src/include/access/spgist_private.h           |  6 +-
 src/include/access/spgxlog.h                  | 29 ++++---
 src/include/access/xact.h                     | 24 +++---
 src/include/access/xlog_internal.h            | 15 ++--
 src/include/access/xlogrecord.h               | 19 ++---
 src/include/catalog/pg_control.h              |  8 +-
 src/include/catalog/storage_xlog.h            |  4 +-
 src/include/commands/dbcommands_xlog.h        |  6 +-
 src/include/commands/sequence_xlog.h          |  2 +-
 src/include/commands/tablespace.h             |  4 +-
 src/include/replication/message.h             |  4 +-
 src/include/replication/origin.h              |  6 +-
 src/include/storage/lockdefs.h                |  2 +-
 src/include/storage/sinval.h                  | 28 +++++--
 src/include/storage/standbydefs.h             | 10 ++-
 src/include/utils/relmapper.h                 |  2 +-
 .../test_custom_rmgrs/test_custom_rmgrs.c     |  2 +-
 src/test/recovery/t/039_end_of_wal.pl         |  5 +-
 75 files changed, 457 insertions(+), 365 deletions(-)

diff --git a/src/backend/access/brin/brin.c b/src/backend/access/brin/brin.c
index 6887e421442..8ef44a0075b 100644
--- a/src/backend/access/brin/brin.c
+++ b/src/backend/access/brin/brin.c
@@ -1135,7 +1135,7 @@ brinbuild(Relation heap, Relation index, IndexInfo *indexInfo)
 
 	if (RelationNeedsWAL(index))
 	{
-		xl_brin_createidx xlrec;
+		xl_brin_createidx xlrec = {0};
 		XLogRecPtr	recptr;
 		Page		page;
 
diff --git a/src/backend/access/brin/brin_pageops.c b/src/backend/access/brin/brin_pageops.c
index 7da97bec43b..a1e8bd0e225 100644
--- a/src/backend/access/brin/brin_pageops.c
+++ b/src/backend/access/brin/brin_pageops.c
@@ -183,7 +183,7 @@ brin_doupdate(Relation idxrel, BlockNumber pagesPerRange,
 		/* XLOG stuff */
 		if (RelationNeedsWAL(idxrel))
 		{
-			xl_brin_samepage_update xlrec;
+			xl_brin_samepage_update xlrec = {0};
 			XLogRecPtr	recptr;
 			uint8		info = XLOG_BRIN_SAMEPAGE_UPDATE;
 
@@ -267,7 +267,7 @@ brin_doupdate(Relation idxrel, BlockNumber pagesPerRange,
 		/* XLOG stuff */
 		if (RelationNeedsWAL(idxrel))
 		{
-			xl_brin_update xlrec;
+			xl_brin_update xlrec = {0};
 			XLogRecPtr	recptr;
 			uint8		info;
 
@@ -423,7 +423,7 @@ brin_doinsert(Relation idxrel, BlockNumber pagesPerRange,
 	/* XLOG stuff */
 	if (RelationNeedsWAL(idxrel))
 	{
-		xl_brin_insert xlrec;
+		xl_brin_insert xlrec = {0};
 		XLogRecPtr	recptr;
 		uint8		info;
 
diff --git a/src/backend/access/brin/brin_revmap.c b/src/backend/access/brin/brin_revmap.c
index 233355cb2d5..57ac044497a 100644
--- a/src/backend/access/brin/brin_revmap.c
+++ b/src/backend/access/brin/brin_revmap.c
@@ -408,7 +408,7 @@ brinRevmapDesummarizeRange(Relation idxrel, BlockNumber heapBlk)
 
 	if (RelationNeedsWAL(idxrel))
 	{
-		xl_brin_desummarize xlrec;
+		xl_brin_desummarize xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.pagesPerRange = revmap->rm_pagesPerRange;
@@ -621,7 +621,7 @@ revmap_physical_extend(BrinRevmap *revmap)
 
 	if (RelationNeedsWAL(revmap->rm_irel))
 	{
-		xl_brin_revmap_extend xlrec;
+		xl_brin_revmap_extend xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.targetBlk = mapBlk;
diff --git a/src/backend/access/gin/ginbtree.c b/src/backend/access/gin/ginbtree.c
index 3d3a9da56b1..d28f79b8dce 100644
--- a/src/backend/access/gin/ginbtree.c
+++ b/src/backend/access/gin/ginbtree.c
@@ -418,7 +418,7 @@ ginPlaceToPage(GinBtree btree, GinBtreeStack *stack,
 		if (RelationNeedsWAL(btree->index) && !btree->isBuild)
 		{
 			XLogRecPtr	recptr;
-			ginxlogInsert xlrec;
+			ginxlogInsert xlrec = {0};
 			BlockIdData childblknos[2];
 
 			xlrec.flags = xlflags;
@@ -433,7 +433,7 @@ ginPlaceToPage(GinBtree btree, GinBtreeStack *stack,
 			{
 				BlockIdSet(&childblknos[0], BufferGetBlockNumber(childbuf));
 				BlockIdSet(&childblknos[1], GinPageGetOpaque(childpage)->rightlink);
-				XLogRegisterData(childblknos,
+				XLogRegisterData((char *) childblknos,
 								 sizeof(BlockIdData) * 2);
 			}
 
@@ -457,7 +457,7 @@ ginPlaceToPage(GinBtree btree, GinBtreeStack *stack,
 		 */
 		Buffer		rbuffer;
 		BlockNumber savedRightLink;
-		ginxlogSplit data;
+		ginxlogSplit data = {0};
 		Buffer		lbuffer = InvalidBuffer;
 		Page		newrootpg = NULL;
 
diff --git a/src/backend/access/gin/gindatapage.c b/src/backend/access/gin/gindatapage.c
index c5d7db28077..7d9a466f1e5 100644
--- a/src/backend/access/gin/gindatapage.c
+++ b/src/backend/access/gin/gindatapage.c
@@ -1839,7 +1839,7 @@ createPostingTree(Relation index, ItemPointerData *items, uint32 nitems,
 	if (RelationNeedsWAL(index) && !is_build)
 	{
 		XLogRecPtr	recptr;
-		ginxlogCreatePostingTree data;
+		ginxlogCreatePostingTree data = {0};
 
 		data.size = rootsize;
 
diff --git a/src/backend/access/gin/ginfast.c b/src/backend/access/gin/ginfast.c
index f50848eb65a..63a072a5688 100644
--- a/src/backend/access/gin/ginfast.c
+++ b/src/backend/access/gin/ginfast.c
@@ -115,7 +115,7 @@ writeListPage(Relation index, Buffer buffer,
 
 	if (RelationNeedsWAL(index))
 	{
-		ginxlogInsertListPage data;
+		ginxlogInsertListPage data = {0};
 		XLogRecPtr	recptr;
 
 		data.rightlink = rightlink;
@@ -224,7 +224,7 @@ ginHeapTupleFastInsert(GinState *ginstate, GinTupleCollector *collector)
 	GinMetaPageData *metadata = NULL;
 	Buffer		buffer = InvalidBuffer;
 	Page		page = NULL;
-	ginxlogUpdateMeta data;
+	ginxlogUpdateMeta data = {0};
 	bool		separateList = false;
 	bool		needCleanup = false;
 	int			cleanupSize;
@@ -281,9 +281,8 @@ ginHeapTupleFastInsert(GinState *ginstate, GinTupleCollector *collector)
 		/*
 		 * We should make sublist separately and append it to the tail
 		 */
-		GinMetaPageData sublist;
+		GinMetaPageData sublist = {0};
 
-		memset(&sublist, 0, sizeof(GinMetaPageData));
 		makeSublist(index, collector->tuples, collector->ntuples, &sublist);
 
 		/*
@@ -567,7 +566,7 @@ shiftList(Relation index, Buffer metabuffer, BlockNumber newHead,
 		Page		page;
 		int			i;
 		int64		nDeletedHeapTuples = 0;
-		ginxlogDeleteListPages data;
+		ginxlogDeleteListPages data = {0};
 		Buffer		buffers[GIN_NDELETE_AT_ONCE];
 		BlockNumber freespace[GIN_NDELETE_AT_ONCE];
 
diff --git a/src/backend/access/gin/ginutil.c b/src/backend/access/gin/ginutil.c
index ff927279cc3..1b228c17540 100644
--- a/src/backend/access/gin/ginutil.c
+++ b/src/backend/access/gin/ginutil.c
@@ -648,7 +648,7 @@ ginUpdateStats(Relation index, const GinStatsData *stats, bool is_build)
 	if (RelationNeedsWAL(index) && !is_build)
 	{
 		XLogRecPtr	recptr;
-		ginxlogUpdateMeta data;
+		ginxlogUpdateMeta data = {0};
 
 		data.locator = index->rd_locator;
 		data.ntuples = 0;
diff --git a/src/backend/access/gin/ginvacuum.c b/src/backend/access/gin/ginvacuum.c
index c9f143f6c31..5b488e89a56 100644
--- a/src/backend/access/gin/ginvacuum.c
+++ b/src/backend/access/gin/ginvacuum.c
@@ -197,7 +197,7 @@ ginDeletePage(GinVacuumState *gvs, BlockNumber deleteBlkno, BlockNumber leftBlkn
 	if (RelationNeedsWAL(gvs->index))
 	{
 		XLogRecPtr	recptr;
-		ginxlogDeletePage data;
+		ginxlogDeletePage data = {0};
 
 		/*
 		 * We can't pass REGBUF_STANDARD for the deleted page, because we
diff --git a/src/backend/access/gist/gistxlog.c b/src/backend/access/gist/gistxlog.c
index c783838495f..b93e831b829 100644
--- a/src/backend/access/gist/gistxlog.c
+++ b/src/backend/access/gist/gistxlog.c
@@ -495,7 +495,7 @@ gistXLogSplit(bool page_is_leaf,
 			  BlockNumber origrlink, GistNSN orignsn,
 			  Buffer leftchildbuf, bool markfollowright)
 {
-	gistxlogPageSplit xlrec;
+	gistxlogPageSplit xlrec = {0};
 	SplitPageLayout *ptr;
 	int			npage = 0;
 	XLogRecPtr	recptr;
@@ -550,7 +550,7 @@ XLogRecPtr
 gistXLogPageDelete(Buffer buffer, FullTransactionId xid,
 				   Buffer parentBuffer, OffsetNumber downlinkOffset)
 {
-	gistxlogPageDelete xlrec;
+	gistxlogPageDelete xlrec = {0};
 	XLogRecPtr	recptr;
 
 	xlrec.deleteXid = xid;
@@ -592,7 +592,7 @@ void
 gistXLogPageReuse(Relation rel, Relation heaprel,
 				  BlockNumber blkno, FullTransactionId deleteXid)
 {
-	gistxlogPageReuse xlrec_reuse;
+	gistxlogPageReuse xlrec_reuse = {0};
 
 	/*
 	 * Note that we don't register the buffer with the record, because this
@@ -629,7 +629,7 @@ gistXLogUpdate(Buffer buffer,
 			   IndexTuple *itup, int ituplen,
 			   Buffer leftchildbuf)
 {
-	gistxlogPageUpdate xlrec;
+	gistxlogPageUpdate xlrec = {0};
 	int			i;
 	XLogRecPtr	recptr;
 
@@ -668,7 +668,7 @@ XLogRecPtr
 gistXLogDelete(Buffer buffer, OffsetNumber *todelete, int ntodelete,
 			   TransactionId snapshotConflictHorizon, Relation heaprel)
 {
-	gistxlogDelete xlrec;
+	gistxlogDelete xlrec = {0};
 	XLogRecPtr	recptr;
 
 	xlrec.isCatalogRel = RelationIsAccessibleInLogicalDecoding(heaprel);
diff --git a/src/backend/access/hash/hash.c b/src/backend/access/hash/hash.c
index e88ddb32a05..f565cfc77a8 100644
--- a/src/backend/access/hash/hash.c
+++ b/src/backend/access/hash/hash.c
@@ -613,7 +613,7 @@ loop_top:
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_hash_update_meta_page xlrec;
+		xl_hash_update_meta_page xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.ntuples = metap->hashm_ntuples;
@@ -819,7 +819,7 @@ hashbucketcleanup(Relation rel, Bucket cur_bucket, Buffer bucket_buf,
 			/* XLOG stuff */
 			if (RelationNeedsWAL(rel))
 			{
-				xl_hash_delete xlrec;
+				xl_hash_delete xlrec = {0};
 				XLogRecPtr	recptr;
 
 				xlrec.clear_dead_marking = clear_dead_marking;
diff --git a/src/backend/access/hash/hashinsert.c b/src/backend/access/hash/hashinsert.c
index 0cefbacc96e..5ba623393a8 100644
--- a/src/backend/access/hash/hashinsert.c
+++ b/src/backend/access/hash/hashinsert.c
@@ -215,7 +215,7 @@ restart_insert:
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_hash_insert xlrec;
+		xl_hash_insert xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.offnum = itup_off;
@@ -423,7 +423,7 @@ _hash_vacuum_one_page(Relation rel, Relation hrel, Buffer metabuf, Buffer buf)
 		/* XLOG stuff */
 		if (RelationNeedsWAL(rel))
 		{
-			xl_hash_vacuum_one_page xlrec;
+			xl_hash_vacuum_one_page xlrec = {0};
 			XLogRecPtr	recptr;
 
 			xlrec.isCatalogRel = RelationIsAccessibleInLogicalDecoding(hrel);
diff --git a/src/backend/access/hash/hashovfl.c b/src/backend/access/hash/hashovfl.c
index 8cfb6ce75d6..69e90ffac5b 100644
--- a/src/backend/access/hash/hashovfl.c
+++ b/src/backend/access/hash/hashovfl.c
@@ -382,7 +382,7 @@ found:
 	if (RelationNeedsWAL(rel))
 	{
 		XLogRecPtr	recptr;
-		xl_hash_add_ovfl_page xlrec;
+		xl_hash_add_ovfl_page xlrec = {0};
 
 		xlrec.bmpage_found = page_found;
 		xlrec.bmsize = metap->hashm_bmsize;
@@ -644,7 +644,7 @@ _hash_freeovflpage(Relation rel, Buffer bucketbuf, Buffer ovflbuf,
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_hash_squeeze_page xlrec;
+		xl_hash_squeeze_page xlrec = {0};
 		XLogRecPtr	recptr;
 		int			i;
 		bool		mod_wbuf = false;
@@ -987,7 +987,7 @@ readpage:
 					if (RelationNeedsWAL(rel))
 					{
 						XLogRecPtr	recptr;
-						xl_hash_move_page_contents xlrec;
+						xl_hash_move_page_contents xlrec = {0};
 
 						xlrec.ntups = nitups;
 						xlrec.is_prim_bucket_same_wrt = (wbuf == bucket_buf);
diff --git a/src/backend/access/hash/hashpage.c b/src/backend/access/hash/hashpage.c
index 8e220a3ae16..61a0badbfaa 100644
--- a/src/backend/access/hash/hashpage.c
+++ b/src/backend/access/hash/hashpage.c
@@ -386,7 +386,7 @@ _hash_init(Relation rel, double num_tuples, ForkNumber forkNum)
 	/* XLOG stuff */
 	if (use_wal)
 	{
-		xl_hash_init_meta_page xlrec;
+		xl_hash_init_meta_page xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.num_tuples = num_tuples;
@@ -462,7 +462,7 @@ _hash_init(Relation rel, double num_tuples, ForkNumber forkNum)
 	/* XLOG stuff */
 	if (use_wal)
 	{
-		xl_hash_init_bitmap_page xlrec;
+		xl_hash_init_bitmap_page xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.bmsize = metap->hashm_bmsize;
@@ -899,7 +899,7 @@ restart_expand:
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_hash_split_allocate_page xlrec;
+		xl_hash_split_allocate_page xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.new_bucket = maxbucket;
@@ -1297,7 +1297,7 @@ _hash_splitbucket(Relation rel,
 	if (RelationNeedsWAL(rel))
 	{
 		XLogRecPtr	recptr;
-		xl_hash_split_complete xlrec;
+		xl_hash_split_complete xlrec = {0};
 
 		xlrec.old_bucket_flag = oopaque->hasho_flag;
 		xlrec.new_bucket_flag = nopaque->hasho_flag;
diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 98d53caeea8..c8b1ef7d372 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -2218,8 +2218,8 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 	/* XLOG stuff */
 	if (RelationNeedsWAL(relation))
 	{
-		xl_heap_insert xlrec;
-		xl_heap_header xlhdr;
+		xl_heap_insert xlrec = {0};
+		xl_heap_header xlhdr = {0};
 		XLogRecPtr	recptr;
 		Page		page = BufferGetPage(buffer);
 		uint8		info = XLOG_HEAP_INSERT;
@@ -3149,8 +3149,8 @@ l1:
 	 */
 	if (RelationNeedsWAL(relation))
 	{
-		xl_heap_delete xlrec;
-		xl_heap_header xlhdr;
+		xl_heap_delete xlrec = {0};
+		xl_heap_header xlhdr = {0};
 		XLogRecPtr	recptr;
 
 		/*
@@ -3948,7 +3948,7 @@ l2:
 
 		if (RelationNeedsWAL(relation))
 		{
-			xl_heap_lock xlrec;
+			xl_heap_lock xlrec = {0};
 			XLogRecPtr	recptr;
 
 			XLogBeginInsert();
@@ -5283,7 +5283,7 @@ failed:
 	 */
 	if (RelationNeedsWAL(relation))
 	{
-		xl_heap_lock xlrec;
+		xl_heap_lock xlrec = {0};
 		XLogRecPtr	recptr;
 
 		XLogBeginInsert();
@@ -6034,7 +6034,7 @@ l4:
 		/* XLOG stuff */
 		if (RelationNeedsWAL(rel))
 		{
-			xl_heap_lock_updated xlrec;
+			xl_heap_lock_updated xlrec = {0};
 			XLogRecPtr	recptr;
 			Page		page = BufferGetPage(buf);
 
@@ -6201,7 +6201,7 @@ heap_finish_speculative(Relation relation, const ItemPointerData *tid)
 	/* XLOG stuff */
 	if (RelationNeedsWAL(relation))
 	{
-		xl_heap_confirm xlrec;
+		xl_heap_confirm xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.offnum = ItemPointerGetOffsetNumber(tid);
@@ -6346,7 +6346,7 @@ heap_abort_speculative(Relation relation, const ItemPointerData *tid)
 	 */
 	if (RelationNeedsWAL(relation))
 	{
-		xl_heap_delete xlrec;
+		xl_heap_delete xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.flags = XLH_DELETE_IS_SUPER;
@@ -6646,7 +6646,7 @@ heap_inplace_update_and_unlock(Relation relation,
 	/* XLOG stuff */
 	if (RelationNeedsWAL(relation))
 	{
-		xl_heap_inplace xlrec;
+		xl_heap_inplace xlrec = {0};
 		PGAlignedBlock copied_buffer;
 		char	   *origdata = (char *) BufferGetBlock(buffer);
 		Page		page = BufferGetPage(buffer);
@@ -6667,7 +6667,7 @@ heap_inplace_update_and_unlock(Relation relation,
 		XLogBeginInsert();
 		XLogRegisterData(&xlrec, MinSizeOfHeapInplace);
 		if (nmsgs != 0)
-			XLogRegisterData(invalMessages,
+			XLogRegisterData((char *) invalMessages,
 							 nmsgs * sizeof(SharedInvalidationMessage));
 
 		/* register block matching what buffer will look like after changes */
@@ -8884,7 +8884,7 @@ XLogRecPtr
 log_heap_visible(Relation rel, Buffer heap_buffer, Buffer vm_buffer,
 				 TransactionId snapshotConflictHorizon, uint8 vmflags)
 {
-	xl_heap_visible xlrec;
+	xl_heap_visible xlrec = {0};
 	XLogRecPtr	recptr;
 	uint8		flags;
 
@@ -8920,9 +8920,9 @@ log_heap_update(Relation reln, Buffer oldbuf,
 				HeapTuple old_key_tuple,
 				bool all_visible_cleared, bool new_all_visible_cleared)
 {
-	xl_heap_update xlrec;
-	xl_heap_header xlhdr;
-	xl_heap_header xlhdr_idx;
+	xl_heap_update xlrec = {0};
+	xl_heap_header xlhdr = {0};
+	xl_heap_header xlhdr_idx = {0};
 	uint8		info;
 	uint16		prefix_suffix[2];
 	uint16		prefixlen = 0,
@@ -9139,7 +9139,7 @@ log_heap_update(Relation reln, Buffer oldbuf,
 static XLogRecPtr
 log_heap_new_cid(Relation relation, HeapTuple tup)
 {
-	xl_heap_new_cid xlrec;
+	xl_heap_new_cid xlrec = {0};
 
 	XLogRecPtr	recptr;
 	HeapTupleHeader hdr = tup->t_data;
diff --git a/src/backend/access/heap/heapam_xlog.c b/src/backend/access/heap/heapam_xlog.c
index f765345e9e4..46fc689302d 100644
--- a/src/backend/access/heap/heapam_xlog.c
+++ b/src/backend/access/heap/heapam_xlog.c
@@ -31,7 +31,7 @@ heap_xlog_prune_freeze(XLogReaderState *record)
 {
 	XLogRecPtr	lsn = record->EndRecPtr;
 	char	   *maindataptr = XLogRecGetData(record);
-	xl_heap_prune xlrec;
+	xl_heap_prune xlrec = {0};
 	Buffer		buffer;
 	RelFileLocator rlocator;
 	BlockNumber blkno;
@@ -504,7 +504,7 @@ heap_xlog_insert(XLogReaderState *record)
 		char		data[MaxHeapTupleSize];
 	}			tbuf;
 	HeapTupleHeader htup;
-	xl_heap_header xlhdr;
+	xl_heap_header xlhdr = {0};
 	uint32		newlen;
 	Size		freespace = 0;
 	RelFileLocator target_locator;
@@ -828,7 +828,7 @@ heap_xlog_update(XLogReaderState *record, bool hot_update)
 		HeapTupleHeaderData hdr;
 		char		data[MaxHeapTupleSize];
 	}			tbuf;
-	xl_heap_header xlhdr;
+	xl_heap_header xlhdr = {0};
 	uint32		newlen;
 	Size		freespace = 0;
 	XLogRedoAction oldaction;
diff --git a/src/backend/access/heap/pruneheap.c b/src/backend/access/heap/pruneheap.c
index 632c2427952..d609b63ef97 100644
--- a/src/backend/access/heap/pruneheap.c
+++ b/src/backend/access/heap/pruneheap.c
@@ -2174,17 +2174,17 @@ log_heap_prune_and_freeze(Relation relation, Buffer buffer,
 						  OffsetNumber *dead, int ndead,
 						  OffsetNumber *unused, int nunused)
 {
-	xl_heap_prune xlrec;
+	xl_heap_prune xlrec = {0};
 	XLogRecPtr	recptr;
 	uint8		info;
 	uint8		regbuf_flags_heap;
 
 	/* The following local variables hold data registered in the WAL record: */
 	xlhp_freeze_plan plans[MaxHeapTuplesPerPage];
-	xlhp_freeze_plans freeze_plans;
-	xlhp_prune_items redirect_items;
-	xlhp_prune_items dead_items;
-	xlhp_prune_items unused_items;
+	xlhp_freeze_plans freeze_plans = {0};
+	xlhp_prune_items redirect_items = {0};
+	xlhp_prune_items dead_items = {0};
+	xlhp_prune_items unused_items = {0};
 	OffsetNumber frz_offsets[MaxHeapTuplesPerPage];
 	bool		do_prune = nredirected > 0 || ndead > 0 || nunused > 0;
 	bool		do_set_vm = vmflags & VISIBILITYMAP_VALID_BITS;
diff --git a/src/backend/access/heap/rewriteheap.c b/src/backend/access/heap/rewriteheap.c
index 77fd48eb59e..2f47222a5c0 100644
--- a/src/backend/access/heap/rewriteheap.c
+++ b/src/backend/access/heap/rewriteheap.c
@@ -826,7 +826,7 @@ logical_heap_rewrite_flush_mappings(RewriteState state)
 	{
 		char	   *waldata;
 		char	   *waldata_start;
-		xl_heap_rewrite_mapping xlrec;
+		xl_heap_rewrite_mapping xlrec = {0};
 		Oid			dboid;
 		uint32		len;
 		int			written;
diff --git a/src/backend/access/nbtree/nbtdedup.c b/src/backend/access/nbtree/nbtdedup.c
index 95be0b17939..e20590a5547 100644
--- a/src/backend/access/nbtree/nbtdedup.c
+++ b/src/backend/access/nbtree/nbtdedup.c
@@ -246,7 +246,7 @@ _bt_dedup_pass(Relation rel, Buffer buf, IndexTuple newitem, Size newitemsz,
 	if (RelationNeedsWAL(rel))
 	{
 		XLogRecPtr	recptr;
-		xl_btree_dedup xlrec_dedup;
+		xl_btree_dedup xlrec_dedup = {0};
 
 		xlrec_dedup.nintervals = state->nintervals;
 
diff --git a/src/backend/access/nbtree/nbtinsert.c b/src/backend/access/nbtree/nbtinsert.c
index d17aaa5aa0f..71a62b06692 100644
--- a/src/backend/access/nbtree/nbtinsert.c
+++ b/src/backend/access/nbtree/nbtinsert.c
@@ -1319,8 +1319,8 @@ _bt_insertonpg(Relation rel,
 		/* XLOG stuff */
 		if (RelationNeedsWAL(rel))
 		{
-			xl_btree_insert xlrec;
-			xl_btree_metadata xlmeta;
+			xl_btree_insert xlrec = {0};
+			xl_btree_metadata xlmeta = {0};
 			uint8		xlinfo;
 			XLogRecPtr	recptr;
 			uint16		upostingoff;
@@ -1981,7 +1981,7 @@ _bt_split(Relation rel, Relation heaprel, BTScanInsert itup_key, Buffer buf,
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_btree_split xlrec;
+		xl_btree_split xlrec = {0};
 		uint8		xlinfo;
 		XLogRecPtr	recptr;
 
@@ -2570,9 +2570,9 @@ _bt_newlevel(Relation rel, Relation heaprel, Buffer lbuf, Buffer rbuf)
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_btree_newroot xlrec;
+		xl_btree_newroot xlrec = {0};
 		XLogRecPtr	recptr;
-		xl_btree_metadata md;
+		xl_btree_metadata md = {0};
 
 		xlrec.rootblk = rootblknum;
 		xlrec.level = metad->btm_level;
diff --git a/src/backend/access/nbtree/nbtpage.c b/src/backend/access/nbtree/nbtpage.c
index 4125c185e8b..80f9ec2c846 100644
--- a/src/backend/access/nbtree/nbtpage.c
+++ b/src/backend/access/nbtree/nbtpage.c
@@ -285,7 +285,7 @@ _bt_set_cleanup_info(Relation rel, BlockNumber num_delpages)
 	/* write wal record if needed */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_btree_metadata md;
+		xl_btree_metadata md = {0};
 		XLogRecPtr	recptr;
 
 		XLogBeginInsert();
@@ -472,9 +472,9 @@ _bt_getroot(Relation rel, Relation heaprel, int access)
 		/* XLOG stuff */
 		if (RelationNeedsWAL(rel))
 		{
-			xl_btree_newroot xlrec;
+			xl_btree_newroot xlrec = {0};
 			XLogRecPtr	recptr;
-			xl_btree_metadata md;
+			xl_btree_metadata md = {0};
 
 			XLogBeginInsert();
 			XLogRegisterBuffer(0, rootbuf, REGBUF_WILL_INIT);
@@ -933,7 +933,7 @@ _bt_allocbuf(Relation rel, Relation heaprel)
 				 */
 				if (RelationNeedsWAL(rel) && XLogStandbyInfoActive())
 				{
-					xl_btree_reuse_page xlrec_reuse;
+					xl_btree_reuse_page xlrec_reuse = {0};
 
 					/*
 					 * Note that we don't register the buffer with the record,
@@ -1227,7 +1227,7 @@ _bt_delitems_vacuum(Relation rel, Buffer buf,
 	if (needswal)
 	{
 		XLogRecPtr	recptr;
-		xl_btree_vacuum xlrec_vacuum;
+		xl_btree_vacuum xlrec_vacuum = {0};
 
 		xlrec_vacuum.ndeleted = ndeletable;
 		xlrec_vacuum.nupdated = nupdatable;
@@ -1343,7 +1343,7 @@ _bt_delitems_delete(Relation rel, Buffer buf,
 	if (needswal)
 	{
 		XLogRecPtr	recptr;
-		xl_btree_delete xlrec_delete;
+		xl_btree_delete xlrec_delete = {0};
 
 		xlrec_delete.snapshotConflictHorizon = snapshotConflictHorizon;
 		xlrec_delete.ndeleted = ndeletable;
@@ -1439,7 +1439,7 @@ _bt_delitems_update(BTVacuumPosting *updatable, int nupdatable,
 		{
 			BTVacuumPosting vacposting = updatable[i];
 			Size		itemsz;
-			xl_btree_update update;
+			xl_btree_update update = {0};
 
 			update.ndeletedtids = vacposting->ndeletedtids;
 			memcpy(updatedbuf + offset, &update.ndeletedtids,
@@ -2252,7 +2252,7 @@ _bt_mark_page_halfdead(Relation rel, Relation heaprel, Buffer leafbuf,
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_btree_mark_page_halfdead xlrec;
+		xl_btree_mark_page_halfdead xlrec = {0};
 		XLogRecPtr	recptr;
 
 		xlrec.poffset = poffset;
@@ -2673,8 +2673,8 @@ _bt_unlink_halfdead_page(Relation rel, Buffer leafbuf, BlockNumber scanblkno,
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel))
 	{
-		xl_btree_unlink_page xlrec;
-		xl_btree_metadata xlmeta;
+		xl_btree_unlink_page xlrec = {0};
+		xl_btree_metadata xlmeta = {0};
 		uint8		xlinfo;
 		XLogRecPtr	recptr;
 
diff --git a/src/backend/access/rmgrdesc/clogdesc.c b/src/backend/access/rmgrdesc/clogdesc.c
index 022376045d7..5669f0387c6 100644
--- a/src/backend/access/rmgrdesc/clogdesc.c
+++ b/src/backend/access/rmgrdesc/clogdesc.c
@@ -32,7 +32,7 @@ clog_desc(StringInfo buf, XLogReaderState *record)
 	}
 	else if (info == CLOG_TRUNCATE)
 	{
-		xl_clog_truncate xlrec;
+		xl_clog_truncate xlrec = {0};
 
 		memcpy(&xlrec, rec, sizeof(xl_clog_truncate));
 		appendStringInfo(buf, "page %" PRId64 "; oldestXact %u",
diff --git a/src/backend/access/rmgrdesc/xactdesc.c b/src/backend/access/rmgrdesc/xactdesc.c
index 4f53d3035cc..5e9b08b1dac 100644
--- a/src/backend/access/rmgrdesc/xactdesc.c
+++ b/src/backend/access/rmgrdesc/xactdesc.c
@@ -125,7 +125,7 @@ ParseCommitRecord(uint8 info, xl_xact_commit *xlrec, xl_xact_parsed_commit *pars
 
 	if (parsed->xinfo & XACT_XINFO_HAS_ORIGIN)
 	{
-		xl_xact_origin xl_origin;
+		xl_xact_origin xl_origin = {0};
 
 		/* no alignment is guaranteed, so copy onto stack */
 		memcpy(&xl_origin, data, sizeof(xl_origin));
@@ -220,7 +220,7 @@ ParseAbortRecord(uint8 info, xl_xact_abort *xlrec, xl_xact_parsed_abort *parsed)
 
 	if (parsed->xinfo & XACT_XINFO_HAS_ORIGIN)
 	{
-		xl_xact_origin xl_origin;
+		xl_xact_origin xl_origin = {0};
 
 		/* no alignment is guaranteed, so copy onto stack */
 		memcpy(&xl_origin, data, sizeof(xl_origin));
diff --git a/src/backend/access/rmgrdesc/xlogdesc.c b/src/backend/access/rmgrdesc/xlogdesc.c
index ff078f22264..6b3341d746e 100644
--- a/src/backend/access/rmgrdesc/xlogdesc.c
+++ b/src/backend/access/rmgrdesc/xlogdesc.c
@@ -116,7 +116,7 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 	}
 	else if (info == XLOG_PARAMETER_CHANGE)
 	{
-		xl_parameter_change xlrec;
+		xl_parameter_change xlrec = {0};
 		const char *wal_level_str;
 
 		memcpy(&xlrec, rec, sizeof(xl_parameter_change));
@@ -144,7 +144,7 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 	}
 	else if (info == XLOG_END_OF_RECOVERY)
 	{
-		xl_end_of_recovery xlrec;
+		xl_end_of_recovery xlrec = {0};
 
 		memcpy(&xlrec, rec, sizeof(xl_end_of_recovery));
 		appendStringInfo(buf, "tli %u; prev tli %u; time %s; wal_level %s",
@@ -154,7 +154,7 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 	}
 	else if (info == XLOG_OVERWRITE_CONTRECORD)
 	{
-		xl_overwrite_contrecord xlrec;
+		xl_overwrite_contrecord xlrec = {0};
 
 		memcpy(&xlrec, rec, sizeof(xl_overwrite_contrecord));
 		appendStringInfo(buf, "lsn %X/%08X; time %s",
diff --git a/src/backend/access/spgist/spgdoinsert.c b/src/backend/access/spgist/spgdoinsert.c
index 7c7371c69e8..44e29814b10 100644
--- a/src/backend/access/spgist/spgdoinsert.c
+++ b/src/backend/access/spgist/spgdoinsert.c
@@ -202,7 +202,7 @@ static void
 addLeafTuple(Relation index, SpGistState *state, SpGistLeafTuple leafTuple,
 			 SPPageDesc *current, SPPageDesc *parent, bool isNulls, bool isNew)
 {
-	spgxlogAddLeaf xlrec;
+	spgxlogAddLeaf xlrec = {0};
 
 	xlrec.newPage = isNew;
 	xlrec.storesNulls = isNulls;
@@ -399,7 +399,7 @@ moveLeafs(Relation index, SpGistState *state,
 	OffsetNumber *toDelete;
 	OffsetNumber *toInsert;
 	BlockNumber nblkno;
-	spgxlogMoveLeafs xlrec;
+	spgxlogMoveLeafs xlrec = {0};
 	char	   *leafdata,
 			   *leafptr;
 
@@ -702,7 +702,7 @@ doPickSplit(Relation index, SpGistState *state,
 	int			currentFreeSpace;
 	int			totalLeafSizes;
 	bool		allTheSame;
-	spgxlogPickSplit xlrec;
+	spgxlogPickSplit xlrec = {0};
 	char	   *leafdata,
 			   *leafptr;
 	SPPageDesc	saveCurrent;
@@ -1512,7 +1512,7 @@ spgAddNodeAction(Relation index, SpGistState *state,
 				 int nodeN, Datum nodeLabel)
 {
 	SpGistInnerTuple newInnerTuple;
-	spgxlogAddNode xlrec;
+	spgxlogAddNode xlrec = {0};
 
 	/* Should not be applied to nulls */
 	Assert(!SpGistPageStoresNulls(current->page));
@@ -1719,7 +1719,7 @@ spgSplitNodeAction(Relation index, SpGistState *state,
 	BlockNumber postfixBlkno;
 	OffsetNumber postfixOffset;
 	int			i;
-	spgxlogSplitTuple xlrec;
+	spgxlogSplitTuple xlrec = {0};
 	Buffer		newBuffer = InvalidBuffer;
 
 	/* Should not be applied to nulls */
